Ti.UI.setBackgroundColor('#fff');

Ti.include('svhelper.js');

var uiTest = (function() {
	var api = {};
	
	api.generateLayout = function(data) {
		var view = Ti.UI.createView({ backgroundColor: '#ccc' }),
			label = Ti.UI.createLabel({ text: data, width: 300, height: 100 }),
			image = Ti.UI.createImageView({ image: 'http://developer.appcelerator.com/assets/img/DOCS_big_image.png', width: 200, height: 100 });
		
		view.add(label);
		view.add(image);
		
		label.addEventListener('click', function() {
			api.reload();
		});
		
		return view;
	};
	
	api.reload = function() {
		svhelper.removeAll();
		var views = [];
		
		for (var i = 0; i < 4; i++) {
			views.push(api.generateLayout(i));
		};
		App.sv.views = views;
		
		// Test for HTTPRequest
        App.Request.xhr({
            url: 'https://api.twitter.com/1/statuses/public_timeline.json?trim_user=true',
            json: true,
            timeout:20000,
            callback: function(data) {
                Ti.API.info(data);
            }
        });				
	};
	
	return api;
})();

var refresh = Ti.UI.createLabel({ text: 'Refresh Me', width: 300, height: 50, top: 20, left: 20 });
refresh.addEventListener('click', function() {
	uiTest.reload();
});

App.win.add(refresh);
App.win.add(App.sv);
App.win.open();

setTimeout(function() {
	uiTest.reload();	
}, 50);