var svhelper = (function() {
	var api = {
		create: (function() {
			var sv = Ti.UI.createScrollableView({
				top: 138,
				cacheSize: 11,
				views: [Ti.UI.createView()] // Hack to make sure SV shows up when adding to the window.  It won't show up otherwise
			});
			return sv;
		}),
		removeAll: (function() {
			//App.sv.views = [];
			App.win.remove(App.sv);
			App.sv = null;
			App.sv = api.create();
			App.win.add(App.sv);
				
		    // var count =  App.sv.views.length;    
		    // if(count >= 0) {
		        // var scrollView = Gum.App.ScrollableView;
		        // var scrolledViews = scrollView.views;
		        // for(var i = 0; i < count; i++) {
		            // scrollView.removeView(scrolledViews[i]);
		            // Ti.API.info('***SV VIEW CHECK ' + Gum.App.ScrollableView.views.length);
		        // }
		    // }
			
			App.sv.views = [Ti.UI.createView()];		
		}),		
	};
	
	return api;
})();

var App = {
	win: Titanium.UI.createWindow({ title: 'SV Tests', backgroundColor:'#fff'}),
	sv: svhelper.create()
};

App.Request = {
	xhr: (function(opts) {
        // if (Gum.App.mode == 'Offline' && Ti.Network.online) {
            // Gum.App.networkMode = 'Online';
            // Ti.App.fireEvent('app:onNetworkModeChange', {mode: Gum.App.networkMode});
	    // }

		// Setup the xhr object
		var xhr = Ti.Network.createHTTPClient();

		/**
			AVAILABLE OPTIONS

			timeout 	: int Timeout request
			type		: string GET/POST
			data		: mixed The data to pass
			url			: string The url source to call
			onerror		: funtion A function to execute when there is an XHR error
		*/

		// Set the timeout or a default if one is not provided
		xhr.timeout = (opts.timeout) ? opts.timeout : 10000;	

		// Error Handling
		xhr.onerror = function(e) {
			if(opts.onerror) {
				opts.onerror(e);				
			} else {
				// Gum.log({
					// error: true,
					// msg: e
				// });
				// Gum.Request.retryDialog(opts);
			}
		};


		// Execute when xhr is loaded
		xhr.onload = function() {
            // Gum.log({
                // debug: true,
                // msg: 'xhr request: '+opts.url + " --> " + xhr.status
            // });
			// If successful
			try 
			{
			    var data = null;
			    if (opts.binary) {
			        data = this.responseData;
                } else if (opts.xml) {
			        data = this.responseXML;
                } else {
                    data = this.responseText;
                }
				if(data == null) {
					Gum.log({
						debug: true,
						msg: this
					});
				} else {
					if(opts.callback) {
						// Execute a callback function
						if (opts.json) {
						    try {
						        data = JSON.parse(data);
                            } catch (e1)  {
                                xhr.onerror(e1);
                                return;
                            }
                        }
						opts.callback(data);					
					} else {
						return data;
					}
				}
			}
			// If not successful
			catch(e) {
                xhr.onerror(e);
			};
		};

		// Open the remote connection
		if(opts.type) {
			xhr.open(opts.type, opts.url);
		} else {
			xhr.open('GET', opts.url);
		}

		if(opts.contentType) {
            xhr.setRequestHeader("Content-Type",opts.contentType);
		}

		if(opts.data) {
			// send the data
			xhr.send(opts.data);	
		} else {
			xhr.send(null);
		}		
	})
};